/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class alu_instr extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               alu_instr.class,
               "alu_instr",
               true,
               new ParamDecls()
                   .declareParam("command", ALU.INFO)
                   .declareParam("op1", ArgumentMode.INOUT, OPRNDL.INFO)
                   .declareParam("op2", ArgumentMode.IN, OPRNDR.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IOperation command = (IOperation) getArgument("command", args);
            final IAddressingMode op1 = (IAddressingMode) getArgument("op1", args);
            final IAddressingMode op2 = (IAddressingMode) getArgument("op2", args);

            return new alu_instr(command, op1, op2);
        }
    }

    public static final IInfo INFO = new Info();

    private final IOperation command;
    private final IAddressingMode op1;
    private final IAddressingMode op2;

    public alu_instr(IOperation command, IAddressingMode op1, IAddressingMode op2)
    {
        assert ALU.INFO.isSupported(command);
        assert OPRNDL.INFO.isSupported(op1);
        assert OPRNDR.INFO.isSupported(op2);

        this.command = command;
        this.op1 = op1;
        this.op2 = op2;
    }

    @Override
    public String syntax()
    {
        return String.format("%s %s %s", command.syntax(), op1.syntax(), op2.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s%s00%s", command.image(), op1.image(), op2.image());
    }

    @Override
    public void action()
    {
        SRC1.access().store(op1.access().load());
        SRC2.access().store(op2.access().load());
        command.action();
        op1.access().store(DEST.access().load());
        PC.access().store(DataEngine.execute(EOperatorID.PLUS, PC.access().load(), DataEngine.valueOf(INDEX, 0x2)));
    }
}
