/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.shared;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.type.TypeId;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final Type INDEX = Type.def("INDEX", Type.CARD(0x8));
    public static final Type NIBBLE = Type.def("NIBBLE", Type.CARD(0x4));
    public static final Type BYTE = Type.def("BYTE", Type.INT(0x8));

    public static final Memory GPR = Memory.def(Memory.Kind.REG, "GPR", BYTE, 0x10);
    public static final Memory PC = Memory.def(Memory.Kind.REG, "PC", INDEX, 0x1);
    public static final Memory M = Memory.def(Memory.Kind.MEM, "M", BYTE, 0x100);
    public static final Memory SRC1 = Memory.def(Memory.Kind.VAR, "SRC1", BYTE, 0x1);
    public static final Memory SRC2 = Memory.def(Memory.Kind.VAR, "SRC2", BYTE, 0x1);
    public static final Memory DEST = Memory.def(Memory.Kind.VAR, "DEST", BYTE, 0x1);

    public static final Memory[] __REGISTERS = {GPR, PC};
    public static final Memory[] __MEMORY = {M};
    public static final Memory[] __VARIABLES = {SRC1, SRC2, DEST};
    public static final Label[] __LABELS = {};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 