/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class cop0 extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               cop0.class,
               "cop0",
               false,
               new ParamDecls()
                   .declareParam("cop_fun", Type.CARD(0x15)),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final Location cop_fun = (Location) getArgument("cop_fun", args);

            return new cop0(cop_fun);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "cop0",
                true,
                new ParamDecls()
                    .declareParam("cop_fun", Type.CARD(0x15))
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final Location cop_fun = (Location) getArgument("cop_fun", args);

            return new instruction(
                new cop0(
                    cop_fun
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final Location cop_fun;

    public cop0(Location cop_fun)
    {
        assert Type.CARD(0x15).equals(cop_fun.getType());

        this.cop_fun = cop_fun;
    }

    @Override
    public String syntax()
    {
        return String.format("cop0 %s", cop_fun.load().getRawData().toString());
    }

    @Override
    public String image()
    {
        return String.format("01000000001%s", cop_fun.load().getRawData().toString());
    }

    @Override
    public void action()
    {
    }
}
