/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class la extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               la.class,
               "la",
               true,
               new ParamDecls()
                   .declareParam("rd", ArgumentMode.OUT, REG.INFO)
                   .declareParam("addr", WORD));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final Location addr = (Location) getArgument("addr", args);

            return new la(rd, addr);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rd;
    private final Location addr;

    public la(IAddressingMode rd, Location addr)
    {
        assert REG.INFO.isSupported(rd);
        assert WORD.equals(addr.getType());

        this.rd = rd;
        this.addr = addr;
    }

    @Override
    public String syntax()
    {
        return String.format("la %s, <label>%d", rd.syntax(), addr.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s%s", new lui(rd, addr.bitField(0x10, 0x1f)).image(), new ori(rd, rd, addr.bitField(0x0, 0xf)).image());
    }

    @Override
    public void action()
    {
        new instruction(new lui(rd, addr.bitField(0x10, 0x1f))).action();
        new instruction(new ori(rd, rd, addr.bitField(0x0, 0xf))).action();
    }
}
