/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class srl extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               srl.class,
               "srl",
               false,
               new ParamDecls()
                   .declareParam("rd", ArgumentMode.OUT, REG.INFO)
                   .declareParam("rt", ArgumentMode.IN, REG.INFO)
                   .declareParam("sa", ArgumentMode.IN, REG.INFO),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode sa = (IAddressingMode) getArgument("sa", args);

            return new srl(rd, rt, sa);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "srl",
                true,
                new ParamDecls()
                    .declareParam("rd", ArgumentMode.OUT, REG.INFO)
                    .declareParam("rt", ArgumentMode.IN, REG.INFO)
                    .declareParam("sa", ArgumentMode.IN, REG.INFO)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode sa = (IAddressingMode) getArgument("sa", args);

            return new instruction(
                new srl(
                    rd,
                    rt,
                    sa
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rd;
    private final IAddressingMode rt;
    private final IAddressingMode sa;

    public srl(IAddressingMode rd, IAddressingMode rt, IAddressingMode sa)
    {
        assert REG.INFO.isSupported(rd);
        assert REG.INFO.isSupported(rt);
        assert REG.INFO.isSupported(sa);

        this.rd = rd;
        this.rt = rt;
        this.sa = sa;
    }

    @Override
    public String syntax()
    {
        return String.format("srl %s, %s, %s", rd.syntax(), rt.syntax(), sa.syntax());
    }

    @Override
    public String image()
    {
        return String.format("00000000000%s%s%s000010", rt.image(), rd.image(), sa.image());
    }

    @Override
    public void action()
    {
        rd.access().store(DataEngine.execute(EOperatorID.R_SHIFT, DataEngine.coerce(Type.CARD(0x20), rt.access().load()), DataEngine.coerce(Type.CARD(0x20), sa.access().load())));
    }
}
