/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class LUI extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               LUI.class,
               "LUI",
               false,
               new ParamDecls()
                   .declareParam("rt", ArgumentMode.OUT, R.INFO)
                   .declareParam("offset", SHORT));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location offset = (Location) getArgument("offset", args);

            return new LUI(rt, offset);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rt;
    private final Location offset;

    public LUI(IAddressingMode rt, Location offset)
    {
        assert R.INFO.isSupported(rt);
        assert SHORT.equals(offset.getType());

        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("LUI %s, %d", rt.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("00111100000%s%s", rt.image(), offset.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        rt.access().store(DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(WORD, offset.load()), DataEngine.valueOf(WORD, 0x10)));
    }
}
