/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class LW extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               LW.class,
               "LW",
               false,
               new ParamDecls()
                   .declareParam("base", ArgumentMode.IN, R.INFO)
                   .declareParam("rt", ArgumentMode.OUT, R.INFO)
                   .declareParam("offset", SHORT));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode base = (IAddressingMode) getArgument("base", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location offset = (Location) getArgument("offset", args);

            return new LW(base, rt, offset);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode base;
    private final IAddressingMode rt;
    private final Location offset;

    public LW(IAddressingMode base, IAddressingMode rt, Location offset)
    {
        assert R.INFO.isSupported(base);
        assert R.INFO.isSupported(rt);
        assert SHORT.equals(offset.getType());

        this.base = base;
        this.rt = rt;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("LW %s, %d(%s)", rt.syntax(), offset.load().getRawData().intValue(), base.syntax());
    }

    @Override
    public String image()
    {
        return String.format("100011%s%s%s", base.image(), rt.image(), offset.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        rt.access().store(Location.concat(M.access(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(LONG, offset.load()))), M.access(DataEngine.intValue(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(LONG, offset.load()))) + 0x1), M.access(DataEngine.intValue(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(LONG, offset.load()))) + 0x2), M.access(DataEngine.intValue(DataEngine.execute(EOperatorID.PLUS, base.access().load(), DataEngine.coerce(LONG, offset.load()))) + 0x3)).load());
    }
}
