/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVT_S extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               MOVT_S.class,
               "MOVT_S",
               false,
               new ParamDecls()
                   .declareParam("fd", ArgumentMode.OUT, F.INFO)
                   .declareParam("fs", ArgumentMode.IN, F.INFO)
                   .declareParam("cc", COND_CODE));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
            final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
            final Location cc = (Location) getArgument("cc", args);

            return new MOVT_S(fd, fs, cc);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode fd;
    private final IAddressingMode fs;
    private final Location cc;

    public MOVT_S(IAddressingMode fd, IAddressingMode fs, Location cc)
    {
        assert F.INFO.isSupported(fd);
        assert F.INFO.isSupported(fs);
        assert COND_CODE.equals(cc.getType());

        this.fd = fd;
        this.fs = fs;
        this.cc = cc;
    }

    @Override
    public String syntax()
    {
        return String.format("MOVT_S %s, %s", fd.syntax(), fs.syntax());
    }

    @Override
    public String image()
    {
        return String.format("01000110000%s01%s%s010001", cc.load().getRawData().toString(), fs.image(), fd.image());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(FCCR.access().bitField(cc.load(), cc.load()).load()) == 0x1)
        {
            fd.access().store(fs.access().load());
        }
    }
}
