/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MUL_S extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               MUL_S.class,
               "MUL_S",
               false,
               new ParamDecls()
                   .declareParam("fd", ArgumentMode.OUT, F.INFO)
                   .declareParam("fs", ArgumentMode.IN, F.INFO)
                   .declareParam("ft", ArgumentMode.IN, F.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
            final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
            final IAddressingMode ft = (IAddressingMode) getArgument("ft", args);

            return new MUL_S(fd, fs, ft);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode fd;
    private final IAddressingMode fs;
    private final IAddressingMode ft;

    public MUL_S(IAddressingMode fd, IAddressingMode fs, IAddressingMode ft)
    {
        assert F.INFO.isSupported(fd);
        assert F.INFO.isSupported(fs);
        assert F.INFO.isSupported(ft);

        this.fd = fd;
        this.fs = fs;
        this.ft = ft;
    }

    @Override
    public String syntax()
    {
        return String.format("MUL_S %s, %s, %s", fd.syntax(), fs.syntax(), ft.syntax());
    }

    @Override
    public String image()
    {
        return String.format("01000110000%s%s%s000010", ft.image(), fs.image(), fd.image());
    }

    @Override
    public void action()
    {
        fd.access().store(DataEngine.execute(EOperatorID.MUL, fs.access().load(), ft.access().load()));
    }
}
