/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.shared;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.type.TypeId;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final String PC = "CIA";

    public static final Type LONG = Type.def("LONG", Type.INT(0x20));
    public static final Type WORD = Type.def("WORD", Type.CARD(0x20));
    public static final Type SHORT = Type.def("SHORT", Type.INT(0x10));
    public static final Type HWORD = Type.def("HWORD", Type.CARD(0x10));
    public static final Type SBYTE = Type.def("SBYTE", Type.INT(0x8));
    public static final Type BYTE = Type.def("BYTE", Type.CARD(0x8));
    public static final Type BIT = Type.def("BIT", Type.CARD(0x1));
    public static final Type INDEX = Type.def("INDEX", Type.CARD(0x5));
    public static final Type SINGLE = Type.def("SINGLE", Type.FLOAT(0x17, 0x8));
    public static final Type COND_CODE = Type.def("COND_CODE", Type.CARD(0x3));

    public static final Memory GPR = Memory.def(Memory.Kind.REG, "GPR", LONG, 0x20);
    public static final Memory FPR = Memory.def(Memory.Kind.REG, "FPR", SINGLE, 0x20);
    public static final Memory M = Memory.def(Memory.Kind.MEM, "M", BYTE, 0x80000000L);
    public static final Memory CIA = Memory.def(Memory.Kind.REG, "CIA", WORD, 0x1);
    public static final Memory FCCR = Memory.def(Memory.Kind.REG, "FCCR", LONG, 0x1);
    public static final Memory NIA = Memory.def(Memory.Kind.VAR, "NIA", WORD, 0x1);
    public static final Memory JMPADDR = Memory.def(Memory.Kind.VAR, "JMPADDR", WORD, 0x1);
    public static final Memory BRANCH = Memory.def(Memory.Kind.VAR, "BRANCH", BIT, 0x1);
    public static final Memory temp = Memory.def(Memory.Kind.VAR, "temp", Type.CARD(0x21), 0x1);

    public static final Memory[] __REGISTERS = {GPR, FPR, CIA, FCCR};
    public static final Memory[] __MEMORY = {M};
    public static final Memory[] __VARIABLES = {NIA, JMPADDR, BRANCH, temp};
    public static final Label[] __LABELS = {new Label("PC", CIA, 0)};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 